<!-- 文件模板管理 -->
<script lang="ts" setup>
import { Delete } from '@element-plus/icons-vue'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
// import tableHeader from '../../notice/tableHeader.vue'
import type { templateType, typeofSign } from '../file-interface'
import addDDialog from './addDDialog.vue'
import { getPhotoUrl, templateDelete, templateExport, templatePage } from '@/api/system/tool'
import { printJSON } from '@/utils/printUtils'
import { getDictByCode } from '@/api/system/dict'
import { exportFile } from '@/utils/exportUtils'
import { download } from '@/utils/download'
const { proxy } = getCurrentInstance() as any
const createTime = ref()
const searchQuery = reactive({
  templateNo: '', // 编号
  templateName: '', // 名称
  templateCreator: '', // 负责人
  createStartTime: '',
  createEndTime: '',
  limit: 20,
  offset: 1,
  templateType: '',
  ids: [] as string[],
}) // 查询参数
watch(() => createTime.value, (newVal) => {
  if (newVal) {
    searchQuery.createStartTime = newVal[0]
    searchQuery.createEndTime = newVal[1]
  }
  else {
    searchQuery.createStartTime = ''
    searchQuery.createEndTime = ''
  }
})
const loadingTable = ref<boolean>(false) // 表格loading
const total = ref<number>(0) // 数据总条数
const columns = ref([
  { text: '编号', value: 'templateNo', align: 'center', width: '160' },
  { text: '模板名称', value: 'templateName', align: 'center' },
  { text: '模板类型', value: 'templateTypeName', align: 'center' },
  { text: '模板负责人', value: 'templateCreator', align: 'center' },
  { text: '创建时间', value: 'createTime', align: 'center', width: '180' },
  { text: '描述', value: 'templateDesc', align: 'center' },
]) // 表格
const list = ref([]) // 表格数据
const addRef = ref() // 添加/编辑/详情/组件
// 获取类型
const templateTypeMap = ref({}) as any // 模板类型{1: 新建}
const getType = async () => {
  const res = await getDictByCode('templateType')
  res.data.forEach((item: any) => {
    templateTypeMap.value[`${item.value}`] = item.name
  })
}
// 获取数据列表
const getList = () => {
  loadingTable.value = true
  templatePage(searchQuery).then((res) => {
    if (res.code === 200) {
      list.value = res.data.rows.map((item: { templateType: string }) => {
        return {
          ...item,
          templateTypeName: item.templateType ? templateTypeMap.value[item.templateType] : item.templateType, // 模板类型
        }
      })
      total.value = res.data.total
    }
    loadingTable.value = false
  }).catch((_) => {
    loadingTable.value = false
  })
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.limit = val.size
  }
  if (val && val.page) {
    searchQuery.offset = val.page
  }
  getList()
}
// 编辑
const edit = (row: templateType) => {
  addRef.value.initDialog({
    ...row,
    title: '编辑',
  })
}
// 详情
const detail = (row: templateType) => {
  addRef.value.initDialog({
    ...row,
    title: '详情',
  })
}
// 删除
const remove = (row: templateType) => {
  ElMessageBox.confirm(
    `确认删除${row.templateName}吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      templateDelete({ id: (row.id as string) }).then((res) => {
        if (res.code === 200) {
          ElMessage({
            type: 'success',
            message: '删除成功',
          })
          getList()
        }
      })
    })
}
// 搜索
const search = () => {
  getList()
}
// 重置
const reset = () => {
  createTime.value = ''
  searchQuery.createEndTime = ''
  searchQuery.createStartTime = ''
  searchQuery.templateCreator = ''
  searchQuery.templateName = ''
  searchQuery.templateNo = ''
  getList()
}

// 新增
const add = () => {
  addRef.value.initDialog({
    templateType: searchQuery.templateType,
    title: '新增',
  })
}
// 下载
const fileUrl = ref('')
const downRef = ref()
const exportSele = (row: templateType) => {
  if (row.minioFileName) {
    getPhotoUrl(row.minioFileName).then((res) => {
      console.log(row, res.data, 'res.datares.datares.data')
      fileUrl.value = res.data
      // fileUrl.value ? downRef.value.click() : ElMessage('无可下载内容')
      download(res.data, row.templateName as string)
    }).catch(() => {
      ElMessage.error('下载失败')
    })
  }
  else {
    ElMessage('无可下载内容')
  }
}
// 表格被选中的行
const selectList = ref<templateType[]>([])
// 表格多选
const multiSelect = (row: templateType[]) => {
  selectList.value = row
}
// 导出
const exportExcelBtn = () => {
  const loading = ElLoading.service({
    lock: true,
    text: 'Loading',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  if (selectList.value.length) {
    selectList.value.forEach((item) => {
      searchQuery.ids?.push(item.id as string)
    })
  }
  else {
    searchQuery.ids = []
  }
  templateExport(searchQuery).then((res) => {
    exportFile(res.data, '文件模板管理')
    loading.close()
    searchQuery.ids = []
  }).catch((_) => {
    loading.close()
  })
}
// 打印
function printList() {
  const selectIds = selectList.value.map((item: templateType) => item.id)
  // 打印列
  const properties = columns.value.map((item) => {
    return {
      field: item.value,
      displayName: item.text,
    }
  })
  if (selectIds.length <= 0 && list.value.length > 0) {
    printJSON(list.value, properties, '文件模板管理')
  }
  else if (selectIds.length > 0) {
    const printList = list.value.filter((item: templateType) => selectIds.includes(item.id))
    printJSON(printList, properties, '文件模板管理')
  }
  else {
    ElMessage('无可打印内容')
  }
}
onMounted(() => {
  getType().then((_) => {
    getList()
  })
})
</script>

<template>
  <!-- 布局 -->
  <app-container>
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="reset">
      <search-item>
        <el-input v-model="searchQuery.templateNo" placeholder="编号" clearable class="w-50 m-2 normal-input" />
      </search-item>
      <search-item>
        <el-input v-model="searchQuery.templateName" placeholder="模板名称" clearable class="w-50 m-2 normal-input" />
      </search-item>
      <search-item>
        <el-input v-model="searchQuery.templateCreator" placeholder="模板负责人" clearable class="w-50 m-2 normal-input" />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="createTime"
          type="datetimerange"
          format="YYYY-MM-DD HH:mm:ss" value-format="YYYY-MM-DD HH:mm:ss"
          range-separator="至"
          start-placeholder="创建开始时间"
          end-placeholder="创建结束时间"
          clearable
        />
        <!-- <el-date-picker
          v-model="searchQuery.createTime" type="datetime" format="YYYY-MM-DD HH:mm:ss" value-format="YYYY-MM-DD HH:mm:ss"
          placeholder="创建时间"
        /> -->
      </search-item>
      <!-- <template #btns>
        <el-button class="filter-item" type="info" :icon="Delete" :style="{ marginTop: '-10px' }" @click="reset">
          重置
        </el-button>
      </template> -->
    </search-area>
    <table-container>
      <!-- 表头区域 -->
      <template #btns-right>
        <icon-button v-if="proxy.hasPerm('/sys/tool/document/add')" icon="icon-add" title="新建" @click="add" />
        <icon-button v-if="proxy.hasPerm('/sys/tool/document/export')" icon="icon-export" title="导出" @click="exportExcelBtn" />
        <icon-button v-if="proxy.hasPerm('/sys/tool/document/print')" icon="icon-print" title="打印" @click="printList" />
      </template>
      <!-- 表格区域 -->
      <normal-table
        :data="list" :total="total" :columns="columns as any"
        :query="{ limit: searchQuery.limit, offset: searchQuery.offset }" :list-loading="loadingTable"
        :is-showmulti-select="true" :is-multi="true" @change="changePage" @multi-select="multiSelect"
      >
        <template #preColumns>
          <el-table-column label="#" width="55" align="center">
            <template #default="scope">
              {{ (searchQuery.offset - 1) * searchQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
        <template #columns>
          <el-table-column label="操作" align="center" width="170">
            <template #default="{ row }">
              <el-button v-if="proxy.hasPerm('/sys/tool/document/update')" size="small" type="primary" link @click="edit(row)">
                编辑
              </el-button>
              <el-button v-if="proxy.hasPerm('/sys/tool/document/detail')" size="small" type="primary" link @click="detail(row)">
                详情
              </el-button>
              <el-button v-if="proxy.hasPerm('/sys/tool/document/download')" size="small" type="primary" link @click="exportSele(row)">
                下载
              </el-button>
              <el-button v-if="proxy.hasPerm('/sys/tool/document/delete')" size="small" type="danger" link @click="remove(row)">
                删除
              </el-button>
              <!--  -->
              <a
                ref="downRef"
                :href="fileUrl" type="primary"
                target="_blank"
              />
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
    <add-d-dialog ref="addRef" @reset-data="getList" />
  </app-container>
</template>

<style lang="scss" scoped>
.normal-input {
  width: 180px !important;
}

:deep(.el-table__header) {
  background-color: #bbb;
}
</style>
